<?php

namespace App\Http\Controllers\HR;

use App\Fun\Fun;
use App\Model\Hr\HrJobExpLevelModel;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Yajra\DataTables\DataTables;
use Illuminate\Support\Facades\Gate;

class HrJobExpLevelController extends Controller
{

    function __construct()
    {
      $this->middleware('permission:Experience level Create', ['only' => ['create', 'store']]);
      $this->middleware('permission:Experience level List', ['only' => ['index','get_exp_level']]);
      $this->middleware('permission:Experience level Edit', ['only' => ['update','edit']]);
    }
    public function index()
    {
        return view('hr.job-exp-level.index');
    }
    public function get_exp_level()
    {
        $data = HrJobExpLevelModel::get();
        return DataTables::of($data)
            ->addIndexColumn()
            ->addColumn('action', function ($data) {
                $check_language = Fun::lang();
                if ($check_language == 'km') {
                    $edit = "កែសម្រួល";
                } else {
                    $edit = "Edit";
                }
                $btn_edit="";
                if(Gate::check('Experience level Edit')){
                $btn_edit .= '<a href="'.route('hr-exp-level.edit',encrypt($data->id)).'" class="button_warning">'.$edit.'</a>';
                }
                return $btn_edit;
            })

            ->rawColumns(['action' => 'action'])
            ->make(true);
    }

    public function create()
    {
        return view('hr.job-exp-level.create');
    }

    public function store(Request $request)
    {
        $this->validate($request,[
            'name'=>'required',
        ]);

        try{
            $ben = new HrJobExpLevelModel();
            $ben->name = $request->name;
            $ben->note = $request->note;
            $ben->save();
            return redirect()->route('hr-exp-level.index')->with('success','Experience level was inserted successful...');
        }catch(\Exception $ex){
            return back()->withErrors($ex->getMessage())->withInput();
        }
    }

    public function show($id)
    {
        //
    }

    public function edit($id)
    {
        $ben = HrJobExpLevelModel::find(decrypt($id));
        return view('hr.job-exp-level.edit',compact('ben'));
    }

    public function update(Request $request, $id)
    {
        $this->validate($request,[
            'name'=>'required',
        ]);

        try{
            $ben = HrJobExpLevelModel::find($id);
            $ben->name = $request->name;
            $ben->note = $request->note;
            $ben->update();
            return redirect()->route('hr-exp-level.index')->with('success','Experience level was updated successful...');
        }catch(\Exception $ex){
            return back()->withErrors($ex->getMessage())->withInput();
        }
    }


    public function destroy($id)
    {
        //
    }
}
